////////////////////////////////////////////////////////////////////////////
//
// Standard definitions and functions that are used almost everywhere
//
// Burkhard Militzer                                    Urbana 4-9-99
//
#include "Standard.h"

#ifdef USE_MPI
#include <mpi.h>
#endif

ofstream COUT;

////////////////////////////////////////////////////////////////////////////////////////////////////

void Terminate(const int value) {
  
#ifdef USE_MPI
  int errorcode=1;
  MPI_Abort(MPI_COMM_WORLD, errorcode);
#endif

  if (value==0) {
    cout << "Program ended properly." << endl;
  } else {
    cerr << "Exiting now." << endl;
  }

  exit(value);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

// Does this need "ss << ends" ???
string IntToString(const int i) {
  ostringstream ss;
  ss << i;
  return ss.str();
}

// Does this need "ss << ends" ???
string IntToString(const int i, const int d, const char c) {
  ostringstream ss;
  ss << i;
  string s;
  for(int j=0; j<d-int(ss.str().length()); j++) 
    //    s+="0";
    s+=c;
  return s+ss.str();
}

string DoubleToString(const double d) {
  ostringstream ss;
  ss << d;
  return ss.str();
}

bool IsInt(const string & s) {
  const string intChars(" +-0123456789");
  string::size_type j=s.find_first_not_of(intChars);
  return (j == string::npos);
}

int StringToInt(const string & s) {
  if (!IsInt(s))
    error("Parser: Not an integer ",s);
 
  istringstream ss(s);
  int value;
  ss >> value;
  return value;
}

bool IsDouble(const string & s) {
  const string doubleChars(" +-0123456789.edDE");
  string::size_type j=s.find_first_not_of(doubleChars);
  return (j == string::npos);
}

double StringToDouble(const string & s) {
  if (!IsDouble(s))
    error("Parser: Not a double ",s);
  
  istringstream ss(s);
  double value;
  ss >> value;
  return value;
}

string UpperCase(const string & s) {
  string sl;
  for(string::const_iterator p=s.begin();p!=s.end();++p) {
    sl += toupper(*p);
  }
  return sl;
}
 
string LowerCase(const string & s) {
  string sl;
  for(string::const_iterator p=s.begin();p!=s.end();++p) {
    sl += tolower(*p);
  }
  return sl;
}

string Spaces(const int n) {
  string s;
  for(int i=0; i<n; i++) {
    s += " ";
  }
  return s;
}


